#ifndef CODE_H
#define CODE_H


#ifndef INTUITION_INTUITIONBASE_H
#include <intuition/intuitionbase.h>
#endif

/* Compiler specific stuff */

#ifdef _DCC             /* DICE */

#  define __AMIGADATE__ "("__DATE__")"

#  define ASM
#  define SAVEDS       __geta4 
#  define STACKARGS    __stkargs
#  define WBMsg        _WBMsg
#  define REG(x)       __ ## x
  
#  define MAIN         _main

#else                           /* SAS */

#  define ASM          __asm
#  define SAVEDS       __saveds
#  define STACKARGS    __stdargs
#  define WBMsg        _WBenchMsg
#  define REG(x)       register __ ## x

#  define MAIN         __main

#endif


#define AW   ((struct IntuitionBase *)IntuitionBase)->ActiveWindow
#define AWS  ((struct IntuitionBase *)IntuitionBase)->ActiveWindow->WScreen
#define AS   ((struct IntuitionBase *)IntuitionBase)->ActiveScreen
#define FS   ((struct IntuitionBase *)IntuitionBase)->FirstScreen

/* for debugging purpose : to locate enforcer hits which don't have hunk numbers */
#ifdef DEBUG
#  define DO_ENFORCER_HIT {char *x; x = NULL; *x= 0;}
#  define DO_ENFORCER_HIT_VAL(n) {char *x; x = NULL; *x= n;}
#else
#  define DO_ENFORCER_HIT 
#  define DO_ENFORCER_HIT_VAL(n) 
#endif

#endif
